Summary: A CRT screen handling and optimization package.
Name: ncurses
Version: 5.2
%define PATCHDATE 20010114
Release: 5
Copyright: distributable
Group: System Environment/Libraries
URL: http://dickey.his.com/ncurses/ncurses.html
Source0: ftp://dickey.his.com/ncurses/ncurses-5.2-20010113.tar.bz2
Source2: ncurses-linux
Source3: ncurses-linux-m
Source4: ncurses-resetall.sh
Patch1: ncurses-5.2-ospeed.patch
Patch2: ncurses-5.0-setuid2.patch
Patch3: ncurses-5.1-xtermchanges.patch
Patch4: ncurses-5.2-screen.patch
Patch5: ncurses-5.2-kterm.patch
Patch6: ncurses-5.2-cross.diff
Patch100: ftp://dickey.his.com/ncurses/%{Version}/ncurses-%{Version}-20010114.patch.gz
BuildRoot: /var/tmp/%{Name}-root

%define Piclibdir	/opt/Embedix/lipo/piclib
%define Piclibarchdir	%{Piclibdir}/$RPM_ARCH

%description
The curses library routines are a terminal-independent method of
updating character screens with reasonable optimization.  The ncurses
(new curses) library is a freely distributable replacement for the
discontinued 4.4BSD classic curses library.

%package devel
Summary: The development files for applications which use ncurses.
Group: Development/Libraries
#Requires: ncurses = %{PACKAGE_VERSION}

%description devel
The header files and libraries for developing applications that use
the ncurses CRT screen handling and optimization package.

Install the ncurses-devel package if you want to develop applications
which will use ncurses.

%package piclib
Group		: Development/Libraries
Summary		: The pic version of libslang


%description piclib
This installs the pic version of the library useful for library reduction.


%prep
%setup -q
%patch100 -p1
%patch1 -p1 -b .ospeed
%patch2 -p1 -b .setuid
%patch3 -p1 -b .xterm
%patch4 -p1 -b .screen
%patch5 -p1 -b .kterm
%patch6 -p1
find . -name "*.orig" -exec rm -f {} \;

%build
%ifarch i386 | ppc
%define optflags $CFLAGS $RPM_OPT_FLAGS -Os
%endif

%ifarch sh3 | sh4 | sh3eb | sh4eb
%define optflags $CFLAGS -O0
%endif

HOST_OVERRIDE=${HOST_PREFIX:+--host=${HOST_PREFIX}}

CFLAGS="%{optflags} -DPURE_TERMINFO"

if [ $EMB_VARIANT_ROOT ]; then
./configure \
	--with-normal --with-shared --without-debug --without-profile \
	--without-cxx --without-ada --enable-sigwinch --enable-hard-tabs \
	--with-ospeed='unsigned int' \
	--with-install-prefix=$EMB_VARIANT_ROOT/tmp/ncurses-%{Version} \
	 $HOST_OVERRIDE
else
./configure \
	--with-normal --with-shared --without-debug --without-profile \
	--without-cxx --without-ada --enable-sigwinch --enable-hard-tabs \
	--with-ospeed='unsigned int' \
	--with-install-prefix=$RPM_BUILD_ROOT $HOST_OVERRIDE
fi
make

#piclib
cd $RPM_BUILD_DIR/ncurses-%{Version}
rm -f libncurses.da libform.da libmenu.da libpanel.da
ar -rv libncurses.da obj_s/hardscroll.o obj_s/hashmap.o obj_s/lib_addch.o \
obj_s/lib_addstr.o obj_s/lib_beep.o obj_s/lib_bkgd.o obj_s/lib_box.o \
obj_s/lib_chgat.o obj_s/lib_clear.o obj_s/lib_clearok.o obj_s/lib_clrbot.o \
obj_s/lib_clreol.o obj_s/lib_color.o obj_s/lib_colorset.o obj_s/lib_delch.o \
obj_s/lib_delwin.o obj_s/lib_echo.o obj_s/lib_endwin.o obj_s/lib_erase.o \
obj_s/lib_flash.o obj_s/lib_gen.o obj_s/lib_getch.o obj_s/lib_getstr.o \
obj_s/lib_hline.o obj_s/lib_immedok.o obj_s/lib_inchstr.o obj_s/lib_initscr.o \
obj_s/lib_insch.o obj_s/lib_insdel.o obj_s/lib_insstr.o obj_s/lib_instr.o \
obj_s/lib_isendwin.o obj_s/lib_leaveok.o obj_s/lib_mouse.o obj_s/lib_move.o \
obj_s/lib_mvcur.o obj_s/lib_mvwin.o obj_s/lib_newterm.o obj_s/lib_newwin.o \
obj_s/lib_nl.o obj_s/lib_overlay.o obj_s/lib_pad.o obj_s/lib_printw.o \
obj_s/lib_redrawln.o obj_s/lib_refresh.o obj_s/lib_restart.o \
obj_s/lib_scanw.o obj_s/lib_screen.o obj_s/lib_scroll.o obj_s/lib_scrollok.o \
obj_s/lib_scrreg.o obj_s/lib_set_term.o obj_s/lib_slk.o \
obj_s/lib_slkatr_set.o obj_s/lib_slkatrof.o obj_s/lib_slkatron.o \
obj_s/lib_slkatrset.o obj_s/lib_slkattr.o obj_s/lib_slkclear.o \
obj_s/lib_slkcolor.o obj_s/lib_slkinit.o obj_s/lib_slklab.o \
obj_s/lib_slkrefr.o obj_s/lib_slkset.o obj_s/lib_slktouch.o \
obj_s/lib_touch.o obj_s/lib_tstp.o obj_s/lib_ungetch.o obj_s/lib_vidattr.o \
obj_s/lib_vline.o obj_s/lib_wattroff.o obj_s/lib_wattron.o obj_s/lib_winch.o \
obj_s/lib_window.o obj_s/nc_panel.o obj_s/safe_sprintf.o obj_s/tty_update.o \
obj_s/memmove.o obj_s/sigaction.o obj_s/vsscanf.o obj_s/define_key.o \
obj_s/expanded.o obj_s/keybound.o obj_s/keyok.o obj_s/lib_dft_fgbg.o \
obj_s/lib_freeall.o obj_s/lib_print.o obj_s/resizeterm.o obj_s/tries.o \
obj_s/version.o obj_s/wresize.o obj_s/access.o obj_s/add_tries.o \
obj_s/alloc_entry.o obj_s/alloc_ttype.o obj_s/captoinfo.o obj_s/codes.o \
obj_s/comp_captab.o obj_s/comp_error.o obj_s/comp_expand.o obj_s/comp_hash.o \
obj_s/comp_parse.o obj_s/comp_scan.o obj_s/doalloc.o obj_s/fallback.o \
obj_s/free_ttype.o obj_s/getenv_num.o obj_s/home_terminfo.o \
obj_s/init_keytry.o obj_s/lib_acs.o obj_s/lib_baudrate.o obj_s/lib_cur_term.o \
obj_s/lib_data.o obj_s/lib_has_cap.o obj_s/lib_kernel.o obj_s/lib_keyname.o \
obj_s/lib_longname.o obj_s/lib_napms.o obj_s/lib_options.o obj_s/lib_raw.o \
obj_s/lib_setup.o obj_s/lib_termcap.o obj_s/lib_termname.o \
obj_s/lib_tgoto.o obj_s/lib_ti.o obj_s/lib_tparm.o obj_s/lib_tputs.o \
obj_s/lib_trace.o obj_s/lib_ttyflags.o obj_s/lib_twait.o obj_s/name_match.o \
obj_s/names.o obj_s/parse_entry.o obj_s/read_entry.o obj_s/read_termcap.o \
obj_s/setbuf.o obj_s/strings.o obj_s/unctrl.o obj_s/write_entry.o

ar -rv libform.da obj_s/fld_arg.o obj_s/fld_attr.o obj_s/fld_current.o obj_s/fld_def.o obj_s/fld_dup.o obj_s/fld_ftchoice.o obj_s/fld_ftlink.o obj_s/fld_info.o obj_s/fld_just.o obj_s/fld_link.o obj_s/fld_max.o obj_s/fld_move.o obj_s/fld_newftyp.o obj_s/fld_opts.o obj_s/fld_pad.o obj_s/fld_page.o obj_s/fld_stat.o obj_s/fld_type.o obj_s/fld_user.o obj_s/frm_cursor.o obj_s/frm_data.o obj_s/frm_def.o obj_s/frm_driver.o obj_s/frm_hook.o obj_s/frm_opts.o obj_s/frm_page.o obj_s/frm_post.o obj_s/frm_req_name.o obj_s/frm_scale.o obj_s/frm_sub.o obj_s/frm_user.o obj_s/frm_win.o obj_s/fty_alnum.o obj_s/fty_alpha.o obj_s/fty_enum.o obj_s/fty_int.o obj_s/fty_ipv4.o obj_s/fty_num.o obj_s/fty_regex.o

ar -rv libmenu.da obj_s/m_attribs.o obj_s/m_cursor.o obj_s/m_driver.o obj_s/m_format.o obj_s/m_global.o obj_s/m_hook.o obj_s/m_item_cur.o obj_s/m_item_nam.o obj_s/m_item_new.o obj_s/m_item_opt.o obj_s/m_item_top.o obj_s/m_item_use.o obj_s/m_item_val.o obj_s/m_item_vis.o obj_s/m_items.o obj_s/m_new.o obj_s/m_opts.o obj_s/m_pad.o obj_s/m_pattern.o obj_s/m_post.o obj_s/m_req_name.o obj_s/m_scale.o obj_s/m_spacing.o obj_s/m_sub.o obj_s/m_userptr.o obj_s/m_win.o

ar -rv libpanel.da obj_s/panel.o obj_s/p_above.o obj_s/p_below.o obj_s/p_bottom.o obj_s/p_delete.o obj_s/p_hide.o obj_s/p_hidden.o obj_s/p_move.o obj_s/p_new.o obj_s/p_replace.o obj_s/p_show.o obj_s/p_top.o obj_s/p_update.o obj_s/p_user.o obj_s/p_win.o

%install
rm -rf $RPM_BUILD_ROOT
make install.progs
make install.includes
make install.libs
make install.data
#make includedir=$RPM_BUILD_ROOT/usr/include/ncurses ticdir=$RPM_BUILD_ROOT/usr/share/terminfo install
#ln -s ../l/linux $RPM_BUILD_ROOT/usr/share/terminfo/c/console
#ln -s ncurses/curses.h $RPM_BUILD_ROOT/usr/include/ncurses.h
#for I in curses unctrl eti form menu panel term; do
#	ln -sf ncurses/$I.h $RPM_BUILD_ROOT/usr/include/$I.h
#done
##ln -sf libncurses.a $RPM_BUILD_ROOT/usr/lib/libcurses.a
#install -o root -g root -m 755 -d $RPM_BUILD_ROOT/usr/lib
#ln -sf lib/libncurses.a $RPM_BUILD_ROOT/usr/lib/libcurses.a

%ifarch sparc
install -c -m644 %SOURCE2 $RPM_BUILD_ROOT/usr/share/terminfo/l/linux
install -c -m644 %SOURCE3 $RPM_BUILD_ROOT/usr/share/terminfo/l/linux-m
%endif

#strip -R .comment $RPM_BUILD_ROOT/usr/bin/* || :
#strip -R .comment --strip-unneeded $RPM_BUILD_ROOT/usr/lib/*.so.%{Version}
for i in `ls $RPM_BUILD_ROOT/usr/bin`; do
  strip --strip-all -R .note -R .comment $RPM_BUILD_ROOT/usr/bin/$i
done
export v=%{Version}
for i in `ls $RPM_BUILD_ROOT/usr/lib | grep ".so.$v"`; do
  strip --strip-all -R .note -R .comment $RPM_BUILD_ROOT/usr/lib/$i
done

make clean -C test

# the resetall script
#install -c -m 755 %{SOURCE4} $RPM_BUILD_ROOT/usr/bin/resetall

#EDR if TW requests devel files install them now
if [ $EMB_VARIANT_ROOT ]; then 
   install -d -m 755 $EMB_VARIANT_ROOT/usr/include/ncurses
   install -d -m 755 $EMB_VARIANT_ROOT/usr/lib
   ls -lR $RPM_BUILD_ROOT/usr/include
   cp -fa $RPM_BUILD_ROOT/usr/include/* $EMB_VARIANT_ROOT/usr/include
   cp -fa $RPM_BUILD_ROOT/usr/lib/* $EMB_VARIANT_ROOT/usr/lib
   # Mirror with links the .../usr/include/ncurses/* files
   pushd $EMB_VARIANT_ROOT/usr/include
   for i in $RPM_BUILD_ROOT/usr/include/*
   do
      f=`basename $i`
      ln -f -s $f ncurses/$f
   done
   popd
fi

#piclib
install -o root -g root -m 755 -d $RPM_BUILD_ROOT%{Piclibarchdir}
install -o root -g root -m 644 $RPM_BUILD_DIR/ncurses-%{Version}/libncurses.da $RPM_BUILD_ROOT%{Piclibarchdir}/libncurses-%{Version}.da
install -o root -g root -m 644 $RPM_BUILD_DIR/ncurses-%{Version}/libform.da $RPM_BUILD_ROOT%{Piclibarchdir}/libform-%{Version}.da
install -o root -g root -m 644 $RPM_BUILD_DIR/ncurses-%{Version}/libmenu.da $RPM_BUILD_ROOT%{Piclibarchdir}/libmenu-%{Version}.da
install -o root -g root -m 644 $RPM_BUILD_DIR/ncurses-%{Version}/libpanel.da $RPM_BUILD_ROOT%{Piclibarchdir}/libpanel-%{Version}.da

#EDR install the piclib in the project directory as well
if [ $EMB_VARIANT_ROOT ]; then 
   install -d -m 777 $EMB_VARIANT_ROOT%{Piclibarchdir}
   install -o root -g root -m 644 $RPM_BUILD_DIR/ncurses-%{Version}/libncurses.da $EMB_VARIANT_ROOT%{Piclibarchdir}/libncurses-%{Version}.da
   install -o root -g root -m 644 $RPM_BUILD_DIR/ncurses-%{Version}/libform.da $EMB_VARIANT_ROOT%{Piclibarchdir}/libform-%{Version}.da
   install -o root -g root -m 644 $RPM_BUILD_DIR/ncurses-%{Version}/libmenu.da $EMB_VARIANT_ROOT%{Piclibarchdir}/libmenu-%{Version}.da
   install -o root -g root -m 644 $RPM_BUILD_DIR/ncurses-%{Version}/libpanel.da $EMB_VARIANT_ROOT%{Piclibarchdir}/libpanel-%{Version}.da
fi

#%post -p /sbin/ldconfig

#%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README ANNOUNCE doc/html/announce.html
%attr(755,root,root) /usr/lib/lib*.so.*
/usr/share/terminfo
/usr/share/tabset
/usr/bin
/usr/lib/lib*.so

%files devel
%defattr(-,root,root)
%doc c++ test
%doc doc/html/hackguide.html
%doc doc/html/ncurses-intro.html
/usr/include/*

%files piclib
%{Piclibdir}

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Jan 15 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update
- Add japanese patch from termcap
- Fix ospeed handling

* Mon Jan  1 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add libcurses.a -> libncurses.a symlink (RFE #23023)

* Tue Dec 12 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Use --with-ospeed='unsigned int'

* Fri Nov 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix alpha and ia64
- Rebuild with gcc 2.96-64

* Thu Nov  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 5.2
- Fix typo in man page (Bug #20205)
- update the "screen" terminfo entries to the version supplied with
  screen 3.9.8

* Mon Oct  9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update (fixes the "make menuconfig" bug introduced by the security fix)

* Tue Oct  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix security problem (possible buffer overrun)

* Fri Aug  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add the bugfix patches from the ncurses maintainer

* Thu Jul 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 5.1

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jun  5 2000 Matt Wilson <msw@redhat.com>
- *don't ship symlinks from lib*.so.5 to lib*.so.4!
- use FHS macros

* Fri Jun  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild for 7.0
- /usr/share/man
- update URL for patches
- misc. fixes to spec file

* Mon Mar 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- use the real library version number
- update to 20000319

* Tue Mar  7 2000 Jeff Johnson <jbj@redhat.com>
- rebuild for sparc baud rates > 38400.

* Fri Feb 18 2000 Preston Brown <pbrown@redhat.com>
- xterm terminfo entries from XFree86 3.3.6
- final round of xterm fixes, follow debian policy.

* Sat Feb  5 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- strip libraries

* Thu Feb  3 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- More xterm fixes (Bug #9087)

* Thu Jan 27 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- More xterm fixes from Hans de Goede (Bug #8633)

* Sat Jan 15 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- remove some broken symlinks (leftovers from libncurses.so.5)
- Use %configure (Bug #8484)

* Tue Jan 11 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Add xterm patch from Hans de Goede <hans@highrise.nl>
- Patch 20000108, this fixes a problem with a header file.

* Wed Jan  5 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Add 20000101 patch, hopefully finally fixing the xterm description

* Wed Dec 22 1999 Cristian Gafton <gafton@redhat.com>
- revert to the old major number - because the ABI is not changed (and we
  should be handling the changes via symbol versioning anyway)

* Fri Nov 12 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix a typo in spec
- Add the 19991006 patch, fixing some C++ STL compatibility problems.
- get rid of profiling and debugging versions - we need to save space...

* Thu Nov  4 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- 5.0
- some spec cleanups to make updating easier
- add links *.so.5 to *.so.4 - they are fully binary compatible.
  (Why did they change the invocation number???)

* Wed Sep 22 1999 Cristian Gafton <gafton@redhat.com>
- make clean in the test dir - don't ship any binaries at all.

* Mon Sep 13 1999 Preston Brown <pbrown@redhat.com>
- fixed stripping of test programs.

* Sun Aug 29 1999 Preston Brown <pbrown@redhat.com>
- removed 'flash' capability for xterm; see bug #2820 for details.

* Fri Aug 27 1999 Cristian Gafton <gafton@redhat.com>
- add the resetall script from Marc Merlin <marc@merlins.org>

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- added iris-ansi-net as alias for iris-ansi (bug #2561)

* Fri Jul 30 1999 Michael K. Johnson <johnsonm@redhat.com>
- added ncurses-intro.hmtl and hackguide.html to -devel package [bug #3929]

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- make sure ALL binaries are stripped (incl. test binaries)

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- made xterm terminfo stuff MUCH better.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 16)

* Sat Mar 13 1999 Cristian Gafton <gafton@redhat.com>
- fixed header for C++ compiles

* Fri Mar 12 1999 Jeff Johnson <jbj@redhat.com>
- add terminfo entries for linux/linux-m on sparc (obsolete termfile_sparc).

* Thu Feb 18 1999 Cristian Gafton <gafton@redhat.com>
- updated patchset from original site

* Thu Dec 03 1998 Cristian Gafton <gafton@redhat.com>
- don't build the C++ demo code
- update patch set to the current as of today (redid all the individual
  patches in a single one)

* Wed Oct 14 1998 Cristian Gafton <gafton@redhat.com>
- make sure to strip the binaries

* Wed Sep 23 1998 Cristian Gafton <gafton@redhat.com>
- added another zillion of patches. The spec file *is* ugly
- defattr

* Mon Jul 20 1998 Cristian Gafton <gafton@redhat.com>
- added lots of patches. This spec file is starting to look ugly

* Wed Jul 01 1998 Alan Cox <alan@redhat.com>
- Fix setuid trusting. Open termcap/info files as the real user.

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- added terminfo entry for the poor guys using lat1 and/or lat-2 on their
  consoles... Enjoy linux-lat ! Thanks, Erik !

* Tue Apr 21 1998 Cristian Gafton <gafton@redhat.com>
- new patch to get xterm-color and nxterm terminfo entries
- aliased them to rxvt, as that seems to satisfy everybody

* Sun Apr 12 1998 Cristian Gafton <gafton@redhat.com>
- added %clean section

* Tue Apr 07 1998 Cristian Gafton <gafton@redhat.com>
- removed /usr/lib/terminfo symlink - we shouldn't need that

* Mon Apr 06 1998 Cristian Gafton <gafton@redhat.com>
- updated to 4.2 + patches
- added BuildRoot

* Sat Apr 04 1998 Cristian Gafton <gafton@redhat.com>
- rebuilt with egcs on alpha

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- version 7 didn't rebuild properly on the Alpha somehow -- no real changes
  are in this version

* Tue Dec 09 1997 Erik Troan <ewt@redhat.com>
- TIOCGWINSZ wasn't used properly

* Tue Jul 08 1997 Erik Troan <ewt@redhat.com>
- built against glibc, linked shared libs against -lc

